[HDU 6092] Rikka with Subset

来源:互联网 发布:电视直播回看软件 编辑:程序博客网 时间:2024/05/20 16:35


Rikka with Subset

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)
Total Submission(s): 139    Accepted Submission(s): 49


Problem Description
As we know, Rikka is poor at math. Yuta is worrying about this situation, so he gives Rikka some math tasks to practice. There is one of them:

Yuta has n positive A1An and their sum is m. Then for each subset S of A, Yuta calculates the sum of S

Now, Yuta has got 2n numbers between [0,m]. For each i[0,m], he counts the number of is he got as Bi.

Yuta shows Rikka the array Bi and he wants Rikka to restore A1An.

It is too difficult for Rikka. Can you help her?  
 

Input
The first line contains a number t(1t70), the number of the testcases. 

For each testcase, the first line contains two numbers n,m(1n50,1m104).

The second line contains m+1 numbers B0Bm(0Bi2n).
 

Output
For each testcase, print a single line with n numbers A1An.

It is guaranteed that there exists at least one solution. And if there are different solutions, print the lexicographic minimum one.
 

Sample Input
22 31 1 1 13 31 3 3 1
 

Sample Output
1 21 1 1
Hint
In the first sample, $A$ is $[1,2]$. $A$ has four subsets $[],[1],[2],[1,2]$ and the sums of each subset are $0,1,2,3$. So $B=[1,1,1,1]$

题意:有一个数列 a[] ,长度(n<=50)。b[i] 表示元素和为 i 的集合个数。给你一个数列 b[] ,长度(m<=10000),让你求 a[],并按照其字典序最小输出

思路: 
分析:很多个较小的数字随机组合会求出多个很大的数字,所以从B0向Bm推导,在每求出A序列的一部分这个过程中,更新后续的B序列,更新完的B[i]就是 i 在A序列中出现的次数。 
分析完后,主要的难点就是怎么去让已求出来的A序列随机组合,更新后续的B序列直接减就可以了。看成01背包问题,让m为背包去装 i,初始值为dp[0] = 1,由于i依次增大,A子集随机组合不会重复

如果 B_iBiBB 数组中除了 B_0B0 以外第一个值不为 00 的位置,那么显然 ii 就是 AA 中的最小数。

现在需要求出删掉 ii 后的 BB 数组,过程大概是反向的背包,即从小到大让 B_j-=B_{j-i}Bj=Bji

时间复杂度 O(nm)O(nm)

AC代码
#include<stdio.h>#include<string.h>#include<iostream>#include<algorithm>using namespace std;#define MAX 11000int main(){int T;int n,m;int B[MAX],dp[MAX],num[MAX],ans[MAX];//dp[i]表示:加和为i的子集个数;数组存的是用比i小的数能组成i的情况scanf("%d",&T);while(T--){scanf("%d %d",&n,&m);for(int i=0;i<=m;i++){scanf("%d",&B[i]);}memset(ans,0,sizeof(ans));memset(num,0,sizeof(num));memset(dp,0,sizeof(dp));dp[0]=1;//空集的情况 int cnt=0;for(int i=1;i<=m;i++){num[i]=B[i]-dp[i];//A序列中值为i的个数if(cnt==n) break;for(int j=1;j<=num[i];j++){ans[cnt++]=i; //对A序列赋值for(int k=m;k>=i;k--)//处理成01背包 dp[k]+=dp[k-i];//和为k的A子集个数相加去更新B序列}}for(int i=0;i<n;i++)printf("%d%c",ans[i],i==n-1?'\n':' ');}return 0;}

Rikka with Subset

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)
Total Submission(s): 139    Accepted Submission(s): 49


Problem Description
As we know, Rikka is poor at math. Yuta is worrying about this situation, so he gives Rikka some math tasks to practice. There is one of them:

Yuta has n positive A1An and their sum is m. Then for each subset S of A, Yuta calculates the sum of S

Now, Yuta has got 2n numbers between [0,m]. For each i[0,m], he counts the number of is he got as Bi.

Yuta shows Rikka the array Bi and he wants Rikka to restore A1An.

It is too difficult for Rikka. Can you help her?  
 

Input
The first line contains a number t(1t70), the number of the testcases. 

For each testcase, the first line contains two numbers n,m(1n50,1m104).

The second line contains m+1 numbers B0Bm(0Bi2n).
 

Output
For each testcase, print a single line with n numbers A1An.

It is guaranteed that there exists at least one solution. And if there are different solutions, print the lexicographic minimum one.
 

Sample Input
22 31 1 1 13 31 3 3 1
 

Sample Output
1 21 1 1
Hint
In the first sample, $A$ is $[1,2]$. $A$ has four subsets $[],[1],[2],[1,2]$ and the sums of each subset are $0,1,2,3$. So $B=[1,1,1,1]$
原创粉丝点击